unit CPCTB2KImpComCtrls;

{
Toolbar2000 Import Handler classes
Copyright  2000 by ChoosePill components, Sebastian Modersohn.
Toolbar2000  by Jordan Russell, www.jrsoftware.org
All rights reserved

Use and/or distribution of these classes requires acceptance
of the following Licence Agreement.

LICENSE AGREEMENT:

"Author" herein refers to Sebastian Modersohn from ChoosePill components.
"Software" refers to all files bearing this notice as well as
any other files included with the Toolbar2000 Import Handler classes and
all content in them, regardless of whether any modifications have been made.

1) This notice may not be removed from or altered in any distribution.

2) The Software may NOT be redistributed in ANY FORM (including but
not limited to .PAS, .DCU, .OBJ) after you have obtained it (typically, by
downloading from the Internet) without the express written permission of the
Author.

3) You are permitted to compile the Software into any kind of applications
or Runtime-only packages. ("Compile" refers to the automatic process of
translating the Software's source code into executable Intel x86 machine code
by the Borland Delphi or C++Builder compilers.)

4) This software is provided "as-is", without any express or implied warranty.
In no event shall the Author be held liable for any damages arising from the use
of this software.

5) Full backward compatibility in future versions of the Software is not
guaranteed. In no event shall the Author be held liable for any inconvenience
or damages arising from lack of backward compatibility.

6) The Author may terminate your rights to use the Software for any reason at
his sole discretion.

7) If you do not agree to any of these terms, you are not permitted to use the
Software in any way, and all copies of it must be deleted from your system(s).
}

interface

{$I TB2Ver.inc}

uses Windows, Classes, Forms, Menus, CPCTB2KImp, TB2Toolbar, TB2Item, TB2Dock
     {$IFDEF JR_D4} , ImgList {$ENDIF}, StdCtrls, ComCtrls, TB2ExtItems,
     Controls, CommCtrl;

type
  TCPCToolbarImportHandler = class(TCPCTB2KImportHandler)
  public
    procedure Execute(Source: TComponent); override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterTB2KImportHandler([TToolbar], TCPCToolbarImportHandler);
end;

{ TCPCMenuImportHandler }

procedure TCPCToolbarImportHandler.Execute(Source: TComponent);

  procedure AddButtonItem(AButton: TToolButton);
  var NewItem: TTBCustomItem;
  begin
    if Assigned(AButton) then
    begin
      if AButton.Style in [tbsDivider, tbsSeparator] then
      begin
        {NewItem:=}AddItem(nil, TTBSeparatorItem);
      end else
      begin
        NewItem:=AddItem(nil, TTBItem);
        if Assigned(NewItem) then
        begin
          NewItem.Action:=AButton.Action;

          NewItem.Caption:=AButton.Caption;
          NewItem.Hint:=AButton.Hint;
          NewItem.Checked:=AButton.Down;
          NewItem.Enabled:=AButton.Enabled;
//          NewItem.HelpContext:=AButton.HelpContext;
          NewItem.ImageIndex:=AButton.ImageIndex;
          NewItem.Tag:=AButton.Tag;
          NewItem.Visible:=AButton.Visible;
          if NewItem is TTBItem then
            TTBItem(NewItem).OnClick:=AButton.OnClick;
        end;
      end;
    end;
  end;

  procedure AddEditItem(Source: TCustomEdit);
  var NewItem: TTBEditItem;
  begin
    if Assigned(Source) then
    begin
      NewItem:=TTBEditItem(AddItem(nil, TTBEditItem));
      NewItem.EditWidth:=Source.Width;
      NewItem.Enabled:=Source.Enabled;
      NewItem.HelpContext:=Source.HelpContext;
      NewItem.Hint:=Source.Hint;
      NewItem.Tag:=Source.Tag;
      NewItem.Text:=Source.Text;
      NewItem.Visible:=Source.Visible;
    end;
  end;

var i, Count: Integer;
    Control: TControl;
    TBButton: TTBButton;
begin
//Destination holds the component to which the new items will be added
//it isn't used directly here, but the AddItem method uses it
  if Assigned(Destination) and (Destination<>Source) then
  begin
    if Source is TToolbar then
    begin
      Count:=TToolbar(Source).Perform(TB_BUTTONCOUNT, 0, 0);
      for i:=0 to Count-1 do
      begin
        if TToolbar(Source).Perform(TB_GETBUTTON, i, Longint(@TBButton)) <> 0 then
        begin
          Control:=TControl(TBButton.dwData);
          if Control is TToolButton then
            AddButtonItem(TToolButton(Control)) else
            if Control is TCustomEdit then
              AddEditItem(TCustomEdit(Control));
        end;
      end;
      SetImages(TToolbar(Source).Images);
    end;
  end;
end;

end.
