unit CPCTB2KImpForm;

{
Toolbar2000 Import Handler classes
Copyright  2000 by ChoosePill components, Sebastian Modersohn.
Toolbar2000  by Jordan Russell, www.jrsoftware.org
All rights reserved

Use and/or distribution of these classes requires acceptance
of the following Licence Agreement.

LICENSE AGREEMENT:

"Author" herein refers to Sebastian Modersohn from ChoosePill components.
"Software" refers to all files bearing this notice as well as
any other files included with the Toolbar2000 Import Handler classes and
all content in them, regardless of whether any modifications have been made.

1) This notice may not be removed from or altered in any distribution.

2) The Software may NOT be redistributed in ANY FORM (including but
not limited to .PAS, .DCU, .OBJ) after you have obtained it (typically, by
downloading from the Internet) without the express written permission of the
Author.

3) You are permitted to compile the Software into any kind of applications
or Runtime-only packages. ("Compile" refers to the automatic process of
translating the Software's source code into executable Intel x86 machine code
by the Borland Delphi or C++Builder compilers.)

4) This software is provided "as-is", without any express or implied warranty.
In no event shall the Author be held liable for any damages arising from the use
of this software.

5) Full backward compatibility in future versions of the Software is not
guaranteed. In no event shall the Author be held liable for any inconvenience
or damages arising from lack of backward compatibility.

6) The Author may terminate your rights to use the Software for any reason at
his sole discretion.

7) If you do not agree to any of these terms, you are not permitted to use the
Software in any way, and all copies of it must be deleted from your system(s).
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, TB2Dock, TB2Toolbar, TB2Item, CPCTB2KImp;

type
  TCPCTB2KCCForm = class(TForm)
    TV: TTreeView;
    BnOK: TButton;
    BtnCancel: TButton;
    TBDock1: TTBDock;
    TBToolbar1: TTBToolbar;
    TBIAllForms: TTBItem;
    Label1: TLabel;
    procedure TBIAllFormsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BnOKClick(Sender: TObject);
  private
    ComponentForm: TCustomForm;
    TheHandler: TCPCTB2KImportHandlerClass;
    TheComponent: TComponent;
  public
    procedure FillTV;
  end;

  function ChooseImportSource(AComponentForm: TCustomForm; var HandlerClass: TCPCTB2KImportHandlerClass): TComponent;

implementation

{$R *.DFM}

function ChooseImportSource(AComponentForm: TCustomForm; var HandlerClass: TCPCTB2KImportHandlerClass): TComponent;
begin
  Result:=nil;
  with TCPCTB2KCCForm.Create(Application) do
  begin
    try
      ComponentForm:=AComponentForm;
      if ShowModal=mrOK then
      begin
        Result:=TheComponent;
        HandlerClass:=TheHandler;
      end;
    finally
      Free;
    end;
  end;
end;

procedure TCPCTB2KCCForm.TBIAllFormsClick(Sender: TObject);
begin
  TBIAllForms.Checked:=not TBIAllForms.Checked;
  TV.ShowRoot:=TBIAllForms.Checked;
  FillTV;
end;

procedure TCPCTB2KCCForm.FormShow(Sender: TObject);
begin
  FillTV;
end;

procedure TCPCTB2KCCForm.FillTV;
var i: Integer;

  procedure FillFromForm(AForm: TCustomForm; SingleFormView: Boolean);
  var Node: TTreeNode;
      Text: string;
      i: Integer;
      TempComp: TComponent;

  begin
    if Assigned(AForm) then
    begin
      if not SingleFormView then
      begin
        Text:=AForm.Caption;
        if Text=EmptyStr then
          Text:=AForm.ClassName;
        Node:=TV.Items.AddObject(nil, Text, AForm);
      end else
        Node:=nil;
      for i:=0 to AForm.ComponentCount-1 do
      begin
        TempComp:=AForm.Components[i];
        if not CanImportFrom(TempComp) then
          Continue;
        Text:=TempComp.Name;
        if Text=EmptyStr then
          Text:=TempComp.ClassName;
        TV.Items.AddChildObject(Node, Text, TempComp);
      end;
      if Assigned(Node) and (not Node.HasChildren) then
        Node.Delete;
    end;
  end;

begin
  TV.Items.BeginUpdate;
  try
    TV.Items.Clear;
    if (not TBIAllForms.Checked) and Assigned(ComponentForm) then
      FillFromForm(ComponentForm, True) else
      for i:=0 to Screen.FormCount-1 do
        if Screen.Forms[i]<>Self then
          FillFromForm(Screen.Forms[i], False);
  finally
    TV.Items.EndUpdate;
  end;
end;

procedure TCPCTB2KCCForm.BnOKClick(Sender: TObject);
begin
  if Assigned(TV.Selected) and (TObject(TV.Selected.Data) is TComponent) then
  begin
    TheComponent:=TComponent(TV.Selected.Data);
    TheHandler:=GetImportHandler(TheComponent);
    if Assigned(TheHandler) then
      ModalResult:=mrOK else
//should happen for forms only, when in "Show All Forms" mode
      MessageDlg('Can''t import from this component. Please choose a different',
        mtInformation, [mbOk], 0);
  end else
    MessageDlg('Please choose the component from which the TB2000 items should be imported!',
      mtInformation, [mbOk], 0);
end;

end.
