unit RegCPCTB2KImp;

{
Toolbar2000 Import Handler classes
Copyright  2000 by ChoosePill components, Sebastian Modersohn.
Toolbar2000  by Jordan Russell, www.jrsoftware.org
All rights reserved

Use and/or distribution of these classes requires acceptance
of the following Licence Agreement.

LICENSE AGREEMENT:

"Author" herein refers to Sebastian Modersohn from ChoosePill components.
"Software" refers to all files bearing this notice as well as
any other files included with the Toolbar2000 Import Handler classes and
all content in them, regardless of whether any modifications have been made.

1) This notice may not be removed from or altered in any distribution.

2) The Software may NOT be redistributed in ANY FORM (including but
not limited to .PAS, .DCU, .OBJ) after you have obtained it (typically, by
downloading from the Internet) without the express written permission of the
Author.

3) You are permitted to compile the Software into any kind of applications
or Runtime-only packages. ("Compile" refers to the automatic process of
translating the Software's source code into executable Intel x86 machine code
by the Borland Delphi or C++Builder compilers.)

4) This software is provided "as-is", without any express or implied warranty.
In no event shall the Author be held liable for any damages arising from the use
of this software.

5) Full backward compatibility in future versions of the Software is not
guaranteed. In no event shall the Author be held liable for any inconvenience
or damages arising from lack of backward compatibility.

6) The Author may terminate your rights to use the Software for any reason at
his sole discretion.

7) If you do not agree to any of these terms, you are not permitted to use the
Software in any way, and all copies of it must be deleted from your system(s).
}

interface

{$I TB2Ver.inc}

uses
  Forms, Classes, Controls,
{$IFDEF JR_D6}
  DesignIntf, DesignEditors,
{$ELSE}
  DsgnIntf,
{$ENDIF}
  Windows,
  TB2Toolbar, TB2DsgnItemEditor, TB2Item, CPCTB2KImp, CPCTB2KImpForm,
  Dialogs;

type
  TCPCTB2KExEditor = class(TTBItemsEditor)
  private
    FVerbIndex: Integer;
  public
    procedure ExecuteVerb (Index: Integer); override;
    function GetVerb (Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

{ TCPCTB2KExEditor }

procedure TCPCTB2KExEditor.ExecuteVerb(Index: Integer);
var HandlerClass: TCPCTB2KImportHandlerClass;
    Handler: TCPCTB2KImportHandler;
    Source: TComponent;
begin
  if Index=FVerbIndex then
  begin
    if Component is TTBCustomToolbar then
    begin
      HandlerClass:=nil;
      Source:=ChooseImportSource(GetParentForm(TTBCustomToolbar(Component)), HandlerClass);
      if Assigned(Source) then
      begin
        if TTBCustomToolbar(Component).Items.Count>0 then
        begin
          case MessageDlg('Clear items from the toolbar first?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
            mrYes:
              begin
                Screen.Cursor:=crHourGlass;
                try
                  while TTBCustomToolbar(Component).Items.Count>0 do
                  begin
                    TTBCustomToolbar(Component).Items[0].Free;
                  end;
                finally
                  Screen.Cursor:=crDefault;
                end;
              end;
            mrCancel:
              Exit;
          end;
        end;
        Screen.Cursor:=crHourGlass;
        try
          if Assigned(HandlerClass) then
          begin
            Handler:=HandlerClass.Create;
            try
              Handler.Destination:=Component;
              Handler.Designer:=Designer;
              Handler.Execute(Source);
            finally
              Handler.Free;
            end;
          end;
        finally
          Screen.Cursor:=crDefault;
        end;
      end;
    end;
  end else
    inherited;
end;

function TCPCTB2KExEditor.GetVerb(Index: Integer): string;
begin
  if Index=FVerbIndex then
    Result:='Import Items from...' else
    Result:=inherited GetVerb(Index);
end;

function TCPCTB2KExEditor.GetVerbCount: Integer;
begin
  FVerbIndex:=inherited GetVerbCount;
  Result:=FVerbIndex+1;
end;

procedure Register;
begin
  RegisterComponentEditor (TTBCustomToolbar, TCPCTB2KExEditor);
  RegisterComponentEditor (TTBItemContainer, TCPCTB2KExEditor);
  RegisterComponentEditor (TTBPopupMenu, TCPCTB2KExEditor);
end;

end.
